(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react);
        global.Input = mod.exports;
    }
})(this, function (exports, _react) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _react2 = _interopRequireDefault(_react);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var Input = function (_Component) {
        _inherits(Input, _Component);

        function Input(props) {
            _classCallCheck(this, Input);

            var _this = _possibleConstructorReturn(this, (Input.__proto__ || Object.getPrototypeOf(Input)).call(this, props));

            _this.initialState = {
                id: null,
                name: null,
                className: null,
                type: 'text',
                placeholder: null
            };
            _this.onInputError = null;
            _this.attributes = {};
            _this.validators = [];

            if (props.validators) _this.validators = props.validators;
            _this.onChange = props.onChange || null;
            _this.state = Object.assign({}, _this.initialState, props.attributes);

            _this._handleChange = _this._handleChange.bind(_this);
            return _this;
        }

        _createClass(Input, [{
            key: '_handleChange',
            value: function _handleChange(e) {
                var errorMessage = undefined;
                var foundError = this.validators.some(function (v) {
                    // run validation
                    errorMessage = v(e.target.value);
                    return errorMessage !== undefined;
                });
                if (this.onChange) {
                    this.onChange(e.target, errorMessage, foundError);
                }
            }
        }, {
            key: 'render',
            value: function render() {
                return _react2.default.createElement('input', _extends({}, this.state, {
                    onBlur: this._handleChange,
                    onChange: this._handleChange }));
            }
        }]);

        return Input;
    }(_react.Component);

    exports.default = Input;
});