(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'validator'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('validator'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.validator);
        global.Validators = mod.exports;
    }
})(this, function (exports, _validator) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.ensureEmailFormat = exports.ensureValue = undefined;

    var _validator2 = _interopRequireDefault(_validator);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var ensureValue = exports.ensureValue = function ensureValue(value) {
        if (value === undefined || !value.toString().trim().length) {
            return 'This field is required';
        }
    };

    var ensureEmailFormat = exports.ensureEmailFormat = function ensureEmailFormat(value) {
        if (!_validator2.default.isEmail(value)) {
            return 'This field requires a valid E-Mail format.';
        }
    };
});