import React, { Component } from 'react';

export default class Input extends Component {

    initialState = {
        id: null,
        name: null,
        className: null,
        type: 'text',
        placeholder: null 
    }
    onInputError = null;
    attributes = {};
    validators = [];

    constructor(props) {
        super(props);
        if (props.validators) this.validators = props.validators;
        this.onChange = props.onChange || null;
        this.state = Object.assign({}, this.initialState, props.attributes)

        this._handleChange = this._handleChange.bind(this);
    }

    _handleChange(e) {
        let errorMessage = undefined;
        const foundError = this.validators.some(v => {
            // run validation
            errorMessage = v(e.target.value);
            return (errorMessage !== undefined);
        });
        if (this.onChange) {
            this.onChange(e.target, errorMessage, foundError);
        }
    }

    render() {
        return (
            <input {...this.state}
            onBlur={this._handleChange}
            onChange={this._handleChange} />
        );
    }
}
  